import React, { Component } from 'react';
import PropTypes from 'prop-types';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var classnames = createCommonjsModule(function (module) {
/*!
  Copyright (c) 2017 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
/* global define */

(function () {

	var hasOwn = {}.hasOwnProperty;

	function classNames () {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg) && arg.length) {
				var inner = classNames.apply(null, arg);
				if (inner) {
					classes.push(inner);
				}
			} else if (argType === 'object') {
				for (var key in arg) {
					if (hasOwn.call(arg, key) && arg[key]) {
						classes.push(key);
					}
				}
			}
		}

		return classes.join(' ');
	}

	if (module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else {
		window.classNames = classNames;
	}
}());
});

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".RoundedButtonGroup {\n  --height: 25px;\n\n  position: relative;\n  z-index: 0;\n}\n\n.roundedButtonWrapper {\n  cursor: pointer;\n  display: inline-block;\n  float: left;\n  margin-left: -2px;\n  text-decoration: none;\n  text-align: center;\n}\n\n.roundedButtonWrapper.disabled {\n  opacity: 0.5;\n  cursor: not-allowed;\n}\n\n.RoundedButtonGroup .roundedButtonWrapper .roundedButton {\n  align-items: center;\n  background-color: var(--ui-gray-dark);\n  border: 2px solid var(--ui-border-color-dark);\n  color: var(--text-secondary-color);\n  display: flex;\n  font-size: 11px;\n  font-weight: 500;\n  justify-content: center;\n  height: var(--height);\n  line-height: var(--height);\n  padding: 0 22px;\n  position: relative;\n  text-transform: uppercase;\n  transition: var(--sidebar-transition);\n  z-index: 1;\n}\n\n.roundedButtonWrapper .roundedButton svg {\n  fill: var(--default-color);\n  stroke: var(--default-color);\n}\n\n.roundedButtonWrapper\n  .roundedButton\n  svg\n  .roundedButtonWrapper\n  .roundedButton\n  span {\n  margin: 0 2px;\n}\n\n.roundedButtonWrapper .roundedButton i {\n  line-height: 15px;\n  font-size: 15px;\n}\n\n.bottomLabel {\n  color: var(--text-secondary-color);\n  font-size: 12px;\n  font-weight: 500;\n  line-height: 12px;\n  margin-top: 8px;\n}\n\n.roundedButtonWrapper:first-child {\n  margin-left: 0;\n}\n\n.RoundedButtonGroup .roundedButtonWrapper:first-child .roundedButton {\n  border-bottom-left-radius: var(--height);\n  border-top-left-radius: var(--height);\n}\n\n.RoundedButtonGroup .roundedButtonWrapper:last-child .roundedButton {\n  border-bottom-right-radius: var(--height);\n  border-top-right-radius: var(--height);\n}\n\n.roundedButtonWrapper:hover .roundedButton {\n  background-color: var(--box-background-color);\n  color: var(--ui-gray-dark);\n}\n\n.roundedButtonWrapper.active .roundedButton {\n  background-color: var(--active-color);\n  border-color: var(--ui-border-color-active);\n  color: var(--ui-gray-dark);\n  z-index: 2;\n}\n\n.roundedButtonWrapper:hover\n  .roundedButton\n  svg\n  .roundedButtonWrapper.active\n  .roundedButton\n  svg {\n  fill: var(--ui-gray-dark);\n  stroke: var(--ui-gray-dark);\n}\n";
styleInject(css);

var RoundedButtonGroup =
/*#__PURE__*/
function (_Component) {
  _inherits(RoundedButtonGroup, _Component);

  function RoundedButtonGroup(props) {
    var _this;

    _classCallCheck(this, RoundedButtonGroup);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RoundedButtonGroup).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClickOption", function (value) {
      console.log('onClickOption', value);

      _this.setState({
        value: value
      });

      if (_this.props.onValueChanged) {
        _this.props.onValueChanged(value);
      }
    });

    _this.state = {
      value: props.value
    };
    return _this;
  }

  _createClass(RoundedButtonGroup, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.value !== this.props.value) {
        this.setState({
          value: this.props.value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var className = classnames(RoundedButtonGroup.className, 'clearfix center-table');
      var buttons = this.props.options.map(function (option, index) {
        var className = classnames({
          roundedButtonWrapper: true,
          noselect: true,
          active: _this2.props.value === option.value
        });
        var optionSVG;

        if (option.svgLink) {
          var svgStyle = {
            width: "".concat(option.svgWidth, "px"),
            height: "".concat(option.svgHeight, "px")
          };
          optionSVG = React.createElement("svg", {
            style: svgStyle
          }, React.createElement("use", {
            xlinkHref: option.svgLink
          }));
        }

        var optionText = option.text && React.createElement("span", null, option.text);
        var optionIcon = option.iconClasses && React.createElement("i", {
          className: option.iconClasses
        });
        var bottomLabel = option.bottomLabel && React.createElement("div", {
          className: "bottomLabel"
        }, option.bottomLabel);
        return React.createElement("div", {
          key: index,
          className: className,
          onClick: function onClick() {
            return _this2.onClickOption(option.value);
          }
        }, React.createElement("div", {
          className: "roundedButton"
        }, optionSVG, optionText, optionIcon), bottomLabel);
      });
      return React.createElement("div", {
        className: className
      }, buttons);
    }
  }]);

  return RoundedButtonGroup;
}(Component);

_defineProperty(RoundedButtonGroup, "className", 'RoundedButtonGroup');

_defineProperty(RoundedButtonGroup, "propTypes", {
  options: PropTypes.array,
  value: PropTypes.string,
  onValueChanged: PropTypes.func
});

_defineProperty(RoundedButtonGroup, "defaultProps", {
  options: [],
  value: null
});

var LayoutManager =
/*#__PURE__*/
function (_Component) {
  _inherits(LayoutManager, _Component);

  function LayoutManager() {
    _classCallCheck(this, LayoutManager);

    return _possibleConstructorReturn(this, _getPrototypeOf(LayoutManager).apply(this, arguments));
  }

  _createClass(LayoutManager, [{
    key: "render",
    value: function render() {
      var _this = this;

      var rows = Array.from(new Array(this.props.rows), function (row, i) {
        return i;
      });
      var columns = Array.from(new Array(this.props.columns), function (col, i) {
        return i;
      });
      var numColumns = columns.length;

      if (!this.props.viewportData.length) {
        return '';
      }

      return React.createElement("table", {
        className: this.props.className
      }, React.createElement("tbody", null, rows.map(function (row, rowIndex) {
        return React.createElement("tr", {
          key: rowIndex
        }, columns.map(function (col, colIndex) {
          var viewportIndex = rowIndex * numColumns + colIndex;
          return React.createElement("td", {
            key: colIndex
          }, _this.props.viewportData[viewportIndex]);
        }));
      })));
    }
  }]);

  return LayoutManager;
}(Component);

_defineProperty(LayoutManager, "defaultProps", {
  columns: 1,
  rows: 1,
  className: 'GridLayout',
  viewportData: []
});

_defineProperty(LayoutManager, "propTypes", {
  rows: PropTypes.number.isRequired,
  columns: PropTypes.number.isRequired,
  className: PropTypes.string.isRequired,
  viewportData: PropTypes.array.isRequired
});

var css$1 = ".layoutChooser {\n  border: 1px solid rgba(77,99,110,0.81);\n  border-radius: 8px;\n  padding: 5px 0;\n  position: absolute;\n  z-index: 5000;\n}\n.layoutChooser .selectedBefore {\n  background-color: #5cc3eb;\n}\n.layoutChooser table {\n  margin: 0 auto;\n}\n.layoutChooser table td {\n  cursor: pointer;\n}\n.layoutChooser table td:hover,\n.layoutChooser table td.hover {\n  background-color: #209ac9;\n}\n";
styleInject(css$1);

/**
 * Adds the 'hover' class to cells above and to the left of the current cell
 * This is used to "fill in" the grid that the user will change the layout to,
 * if they click on a specific table cell.
 **/

var LayoutChooser =
/*#__PURE__*/
function (_Component) {
  _inherits(LayoutChooser, _Component);

  function LayoutChooser(props) {
    var _this;

    _classCallCheck(this, LayoutChooser);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LayoutChooser).call(this, props));
    _this.emptyCell = {
      row: -1,
      column: -1
    };
    _this.state = {
      table: [[]],
      selectedCell: _this.props.selectedCell
    };
    _this.highlightCells = _this.highlightCells.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.isRange = _this.isRange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(LayoutChooser, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.highlightCells(this.emptyCell);
    }
  }, {
    key: "onClick",
    value: function onClick(currentCell) {
      this.setState({
        selectedCell: currentCell
      });
      this.highlightCells(currentCell);

      if (this.props.onClick) {
        this.props.onClick(currentCell);
      }

      if (this.props.onChange) {
        this.props.onChange(currentCell);
      }
    }
  }, {
    key: "isRange",
    value: function isRange(cell, parentCell) {
      return cell.row <= parentCell.row && cell.col <= parentCell.col;
    }
  }, {
    key: "highlightCells",
    value: function highlightCells(currentCell) {
      var table = [];

      for (var row = 0; row < this.props.rows; row++) {
        var newRow = [];

        for (var col = 0; col < this.props.columns; col++) {
          var cell = {
            row: row,
            col: col
          };

          if (this.isRange(cell, currentCell)) {
            cell.className = 'hover';
          } else if (this.isRange(currentCell, this.emptyCell) && this.isRange(cell, this.state.selectedCell)) {
            cell.className = 'selectedBefore';
          }

          newRow.push(cell);
        }

        table.push(newRow);
      }

      this.setState({
        table: table
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var columns = this.props.columns;
      var style = {
        display: this.props.visible ? 'block' : 'none',
        minWidth: columns * this.props.boxSize + (columns + 5) * this.props.cellBorder
      };
      return React.createElement("div", {
        className: "layoutChooser pull-left dropdown-menu",
        role: "menu",
        style: style
      }, React.createElement("table", null, React.createElement("tbody", null, this.state.table.map(function (row, i) {
        return React.createElement("tr", {
          key: i
        }, row.map(function (cell, j) {
          return React.createElement("td", {
            className: cell.className,
            style: {
              width: _this2.props.boxSize,
              height: _this2.props.boxSize,
              border: 'solid 1px black'
            },
            key: j,
            onMouseEnter: function onMouseEnter() {
              return _this2.highlightCells(cell);
            },
            onMouseLeave: function onMouseLeave() {
              return _this2.highlightCells(_this2.emptyCell);
            },
            onClick: function onClick() {
              return _this2.onClick(cell);
            }
          });
        }));
      }))));
    }
  }]);

  return LayoutChooser;
}(Component);
LayoutChooser.defaultProps = {
  rows: 3,
  columns: 3,
  visible: true,
  boxSize: 20,
  cellBorder: 1,
  selectedCell: {
    row: -1,
    col: -1
  }
};
LayoutChooser.propTypes = {
  rows: PropTypes.number.isRequired,
  columns: PropTypes.number.isRequired,
  visible: PropTypes.bool.isRequired,
  selectedCell: PropTypes.object,
  boxSize: PropTypes.number.isRequired,
  cellBorder: PropTypes.number.isRequired
};

var LayoutButton =
/*#__PURE__*/
function (_Component) {
  _inherits(LayoutButton, _Component);

  function LayoutButton(props) {
    var _this;

    _classCallCheck(this, LayoutButton);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LayoutButton).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function () {
      _this.setState({
        dropdownVisible: !_this.state.dropdownVisible
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onChange", function (selectedCell) {
      if (_this.props.onChange) {
        _this.props.onChange(selectedCell);
      }
    });

    _this.state = {
      dropdownVisible: props.dropdownVisible
    };
    return _this;
  }

  _createClass(LayoutButton, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.dropdownVisible !== prevProps.dropdownVisible) {
        this.setState({
          dropdownVisible: this.props.dropdownVisible
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: "btn-group"
      }, React.createElement("button", {
        id: "layout",
        type: "button",
        className: "btn btn-sm btn-default dropdown-toggle",
        "data-container": "body",
        "data-toggle": "dropdown",
        "aria-expanded": "false",
        "data-placement": "right",
        title: "Layout",
        rel: "tooltip",
        onClick: this.onClick
      }, React.createElement("span", {
        className: "fa fa-th-large"
      })), React.createElement(LayoutChooser, {
        visible: this.state.dropdownVisible,
        onChange: this.onChange,
        selectedCell: this.props.selectedCell
      }));
    }
  }]);

  return LayoutButton;
}(Component);

_defineProperty(LayoutButton, "defaultProps", {
  dropdownVisible: false
});

_defineProperty(LayoutButton, "propTypes", {
  dropdownVisible: PropTypes.bool.isRequired,
  onChange: PropTypes.func,
  selectedCell: PropTypes.object
});

var css$2 = ":root {\n  --default-color: #9ccef9;\n  --active-color: #20a5d6;\n  --hover-color: #ffffff;\n}\n\n.ToolbarButton {\n  height: 48px;\n  color: var(--default-color);\n  float: left;\n  text-align: center;\n  padding: 0 5px;\n  cursor: pointer;\n\n  -webkit-touch-callout: none; /* iOS Safari */\n  -webkit-user-select: none; /* Safari */\n  -khtml-user-select: none; /* Konqueror HTML */\n  -moz-user-select: none; /* Firefox */\n  -ms-user-select: none; /* Internet Explorer/Edge */\n  user-select: none; /* Non-prefixed version, currently\n                                  supported by Chrome and Opera */\n}\n\n.ToolbarButton svg {\n  height: 30px;\n  width: 48px;\n  fill: var(--default-color);\n  stroke: var(--default-color);\n}\n\n.ToolbarButton:hover {\n  color: var(--hover-color);\n}\n\n.ToolbarButton:hover svg {\n  fill: var(--hover-color);\n  stroke: var(--hover-color);\n}\n\n.ToolbarButton.active,\n.ToolbarButton:active {\n  color: var(--active-color);\n}\n\n.ToolbarButton.active svg,\n.ToolbarButton:active svg {\n  fill: var(--active-color);\n  stroke: var(--active-color);\n}\n\n.ToolbarButton span {\n  font-size: 14px;\n  width: 100%;\n  text-align: center;\n  display: block;\n}\n";
styleInject(css$2);

function ToolbarButton(props) {
  var onClick = function onClick(event) {
    if (props.setToolActive) {
      props.setToolActive(props);
    }
  };

  var className = classnames(props.className, {
    active: props.active
  });
  return React.createElement("div", {
    className: className,
    onClick: onClick
  }, React.createElement("svg", null, React.createElement("use", {
    xlinkHref: props.svgUrl
  })), React.createElement("span", null, props.text));
}
ToolbarButton.defaultProps = {
  command: 'ToolbarButton',
  onClick: function onClick() {
    console.log("ToolbarButton does not have an onClick event");
  },
  className: 'ToolbarButton'
};
ToolbarButton.propTypes = {
  text: PropTypes.string.isRequired,
  svgUrl: PropTypes.string.isRequired,
  active: PropTypes.bool.isRequired,
  className: PropTypes.string.isRequired
};

var css$3 = ".ToolbarSection {\n  background-color: black;\n  height: 60px;\n  border-radius: 8px;\n  padding: 5px;\n}\n";
styleInject(css$3);

var ToolbarSection =
/*#__PURE__*/
function (_Component) {
  _inherits(ToolbarSection, _Component);

  function ToolbarSection(props) {
    var _this;

    _classCallCheck(this, ToolbarSection);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ToolbarSection).call(this, props));
    _this.state = {}; //this.setToolActive = this.setToolActive.bind(this);

    return _this;
  }

  _createClass(ToolbarSection, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var items = this.props.buttons.map(function (item, index) {
        return React.createElement(ToolbarButton, _extends({
          key: index
        }, item, {
          active: item.command === _this2.props.activeCommand
        }));
      });
      return React.createElement("div", {
        className: 'ToolbarSection'
      }, items);
    }
  }]);

  return ToolbarSection;
}(Component);

ToolbarSection.propTypes = {
  buttons: PropTypes.array.isRequired
};

/*Template.loadingIndicator.helpers({
    'percentComplete': function(e) {
        var percentComplete = Session.get('CornerstoneLoadProgress' + this.viewportIndex);
        if (percentComplete && percentComplete !== 100) {
            return percentComplete + '%';
        }
    }
});*/
function ViewportLoadingIndicator(props) {
  return React.createElement("div", {
    className: "loadingIndicator",
    style: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      margin: 'auto',
      textAlign: 'center',
      pointerEvents: 'none'
    }
  }, "Loading ", props.percentComplete);
}
ViewportLoadingIndicator.propTypes = {
  percentComplete: PropTypes.number
};

function ViewportErrorIndicator(props) {
  return React.createElement("div", {
    className: "loadingIndicator",
    style: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      margin: 'auto',
      textAlign: 'center',
      pointerEvents: 'none'
    }
  }, React.createElement("p", null, "Error"), React.createElement("p", {
    className: "description"
  }, "An error has occurred."), React.createElement("p", {
    className: "details"
  }, props.details));
}
ViewportErrorIndicator.propTypes = {
  details: PropTypes.string
};

var css$4 = ":root {\n  --text-secondary-color: #91b9cd;\n  --active-color: #20a5d6;\n  --primary-background-color: #000;\n  --ui-border-color-dark: #3c5d80;\n  --sidebar-transition: all 0.3s ease;\n}\n.ThumbnailEntry.active .ImageThumbnail {\n  border-color: var(--active-color);\n  box-shadow: none;\n  transition: var(--sidebar-transition);\n}\n.ImageThumbnail {\n  background-color: var(--primary-background-color);\n  box-shadow: inset 0 0 0 1px var(--ui-border-color-dark);\n  border: 5px solid transparent;\n  border-radius: 12px;\n  height: 135px;\n  margin: 0 auto;\n  padding: 1px 7px;\n  position: relative;\n  transition: var(--sidebar-transition);\n  width: 217px;\n  -moz-background-clip: padding;\n  -webkit-background-clip: padding;\n  background-clip: padding-box;\n}\n.image-thumbnail-canvas {\n  height: 100%;\n  overflow: hidden;\n  display: flex;\n  justify-content: center;\n}\n.image-thumbnail-canvas img {\n  -webkit-user-drag: none;\n}\n.thumbnailLoadingIndicator {\n  display: none;\n  pointer-events: none;\n  color: var(--text-secondary-color);\n  height: 20px;\n  width: 100%;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  margin: auto;\n  position: absolute;\n}\n.thumbnailLoadingIndicator.d-block {\n  display: block;\n}\n.thumbnailLoadingIndicator p {\n  text-align: center;\n  font-size: 10pt;\n}\n.image-thumbnail-progress-bar {\n  position: relative;\n  width: 100%;\n  height: 3px;\n  top: -5px;\n}\n.image-thumbnail-progress-bar .image-thumbnail-progress-bar-inner {\n  height: 100%;\n  width: 0;\n  border-radius: 5px;\n  background-color: var(--active-color);\n}\n";
styleInject(css$4);

var ImageThumbnail =
/*#__PURE__*/
function (_Component) {
  _inherits(ImageThumbnail, _Component);

  function ImageThumbnail() {
    _classCallCheck(this, ImageThumbnail);

    return _possibleConstructorReturn(this, _getPrototypeOf(ImageThumbnail).apply(this, arguments));
  }

  _createClass(ImageThumbnail, [{
    key: "render",
    value: function render() {
      var loadingOrError;

      if (this.props.error) {
        loadingOrError = React.createElement(ViewportErrorIndicator, null);
      } else if (this.props.loading || !this.props.imageSrc) {
        loadingOrError = React.createElement(ViewportLoadingIndicator, null);
      }

      var showStackLoadingProgressBar = this.props.stackPercentComplete !== undefined;
      return React.createElement("div", {
        className: "ImageThumbnail"
      }, React.createElement("div", {
        className: "image-thumbnail-canvas"
      }, React.createElement("img", {
        className: "static-image",
        src: this.props.imageSrc,
        width: this.props.width,
        height: this.props.height,
        alt: ''
      })), loadingOrError, showStackLoadingProgressBar && React.createElement("div", {
        className: "image-thumbnail-progress-bar"
      }, React.createElement("div", {
        className: "image-thumbnail-progress-bar-inner",
        style: {
          width: "".concat(this.props.stackPercentComplete, "%")
        }
      })));
    }
  }]);

  return ImageThumbnail;
}(Component);

_defineProperty(ImageThumbnail, "propTypes", {
  imageSrc: PropTypes.string,
  loading: PropTypes.bool.isRequired,
  error: PropTypes.bool.isRequired,
  width: PropTypes.number,
  height: PropTypes.number.isRequired,
  stackPercentComplete: PropTypes.number
});

_defineProperty(ImageThumbnail, "defaultProps", {
  loading: false,
  error: false,
  stackPercentComplete: undefined,
  width: undefined,
  height: 123
});

var css$5 = ":root {\n  --series-count-background-color: #678696;\n  --text-primary-color: #fff;\n  --text-secondary-color: #91b9cd;\n  --active-color: #20a5d6;\n}\n.ThumbnailEntry {\n  cursor: pointer;\n  display: table;\n  margin: 0 auto;\n  margin-top: 1rem;\n  margin-bottom: 1.5rem;\n}\n.ThumbnailEntry .p-x-1 {\n  padding: 0 1rem;\n}\n.ThumbnailEntry.draggable {\n  cursor: copy;\n  cursor: -webkit-grab;\n  cursor: -moz-grab;\n}\n.ThumbnailEntry .series-details {\n  display: flex;\n  flex-direction: row;\n  color: var(--text-primary-color);\n  font-size: 14px;\n  line-height: 1.3em;\n  margin-top: 5px;\n  margin-left: 1rem;\n  margin-right: 1rem;\n  max-width: 217px;\n  min-height: 36px;\n  position: relative;\n  word-wrap: break-word;\n}\n.ThumbnailEntry .series-details .series-description {\n  flex-grow: 1;\n}\n.ThumbnailEntry .series-details.info-only .series-description {\n  display: none;\n}\n.ThumbnailEntry .series-details.info-only .series-information {\n  display: flex;\n  flex-grow: 1;\n  float: none;\n  max-width: none;\n  padding-right: 0;\n}\n.ThumbnailEntry .series-details.info-only .series-information .item {\n  flex: 1;\n  text-align: center;\n}\n.ThumbnailEntry .series-details.info-only .series-information .item .icon,\n.ThumbnailEntry .series-details.info-only .series-information .item .value {\n  display: inline;\n  float: none;\n  line-height: 25px;\n}\n.ThumbnailEntry .series-details.info-only .series-information .item .value {\n  margin-left: 0;\n  width: auto;\n}\n.ThumbnailEntry .series-information {\n  padding-right: 4px;\n  max-width: 50px;\n}\n.ThumbnailEntry .series-information .item-frames .icon {\n  height: 18px;\n}\n.ThumbnailEntry .series-information .value {\n  color: var(--text-secondary-color);\n  display: inline-block;\n  float: right;\n  font-size: 12px;\n  margin-left: 4px;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  width: calc(100% - 15px);\n}\n.ThumbnailEntry .series-information .icon {\n  color: var(--active-color);\n  display: inline-block;\n  float: left;\n  font-size: 10px;\n  font-weight: 900;\n  text-align: right;\n  width: 11px;\n}\n.ThumbnailEntry .series-information .icon div {\n  background-color: var(--series-count-background-color);\n  margin-top: 6px;\n  position: relative;\n}\n.ThumbnailEntry .series-information .icon div:after {\n  background-color: var(--active-color);\n  box-shadow: 1px 1px rgba(0,0,0,0.115);\n  left: -5px;\n  position: absolute;\n  top: -5px;\n}\n.ThumbnailEntry .series-information .icon div,\n.ThumbnailEntry .series-information .icon div:after {\n  border: 1px solid var(--series-count-background-color);\n  content: '';\n  display: inline-block;\n  height: 11px;\n  width: 11px;\n}\n.image-thumbnail-clone {\n  z-index: 100000;\n  pointer-events: none;\n}\n.image-thumbnail-clone:hover {\n  border-color: var(--hover-color);\n  box-shadow: none;\n}\n";
styleInject(css$5);

// https://github.com/swederik/dragula/blob/ccc15d75186f5168e7abadbe3077cf12dab09f8b/styleProperty.js
var browserProps = {};

function eachVendor(prop, fn) {
  var prefixes = ['Webkit', 'Moz', 'ms', 'O'];
  fn(prop);

  for (var i = 0; i < prefixes.length; i++) {
    fn(prefixes[i] + prop.charAt(0).toUpperCase() + prop.slice(1));
  }
}

function check(property, testValue) {
  var sandbox = document.createElement('iframe');
  var element = document.createElement('p');
  document.body.appendChild(sandbox);
  sandbox.contentDocument.body.appendChild(element);
  var support = set$1(element, property, testValue); // We have to do this because remove() is not supported by IE11 and below

  sandbox.parentElement.removeChild(sandbox);
  return support;
}

function checkComputed(el, prop) {
  var computed = window.getComputedStyle(el).getPropertyValue(prop);
  return computed !== void 0 && computed.length > 0 && computed !== 'none';
}

function set$1(el, prop, value) {
  var match = false;

  if (browserProps[prop] === void 0) {
    eachVendor(prop, function (vendorProp) {
      if (el.style[vendorProp] !== void 0 && match === false) {
        el.style[vendorProp] = value;

        if (checkComputed(el, vendorProp)) {
          match = true;
          browserProps[prop] = vendorProp;
        }
      }
    });
  } else {
    el.style[browserProps[prop]] = value;
    return true;
  }

  return match;
}

var styleProperty = {
  check: check,
  set: set$1
};

// if browser supports translate property

var supportsTransform = styleProperty.check('transform', 'translate(1px, 1px)');
var TOUCH_EVENTS = ['touchstart', 'touchmove', 'touchend'];

function getOffset(element) {
  var rect = element.getBoundingClientRect();
  return {
    top: rect.top + document.body.scrollTop,
    left: rect.left + document.body.scrollLeft
  };
}

var ThumbnailEntry =
/*#__PURE__*/
function (_Component) {
  _inherits(ThumbnailEntry, _Component);

  function ThumbnailEntry(props) {
    var _this;

    _classCallCheck(this, ThumbnailEntry);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ThumbnailEntry).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function () {
      if (_this.props.onClick) {
        _this.props.onClick();
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onDoubleClick", function () {
      if (_this.props.onDoubleClick) {
        _this.props.onDoubleClick();
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onMouseDown", function (event) {
      if (_this.props.supportsDragAndDrop) {
        _this.dragStartHandler(event);
      } // Stop text selection


      event.preventDefault();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onTouchStart", function (event) {
      if (_this.props.supportsDragAndDrop) {
        _this.dragStartHandler(event);
      } // Prevent default to stop grab-scrolling page on touch devices


      event.preventDefault();
    });

    _this.state = {
      diff: {
        x: 0,
        y: 0
      },
      startPosition: {},
      translateElement: {},
      dragging: false,
      elementTopLeft: {}
    };
    _this.dragStartHandler = _this.dragStartHandler.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.dragHandler = _this.dragHandler.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.dragEndHandler = _this.dragEndHandler.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.element = React.createRef();
    return _this;
  }

  _createClass(ThumbnailEntry, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = this.element.current; // Note: There is no other way to add non-passive event listeners yet.
      // See https://github.com/facebook/react/issues/6436

      node.addEventListener('touchstart', this.onTouchStart, {
        passive: false
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var node = this.element.current;
      node.removeEventListener('touchstart', this.onTouchStart);
    }
  }, {
    key: "render",
    value: function render() {
      var hasInstanceNumber = this.props.instanceNumber !== undefined;
      var className = classnames('ThumbnailEntry noselect', {
        active: this.props.active
      }, {
        draggable: this.props.supportsDragAndDrop
      });
      var draggableStyle;

      if (supportsTransform) {
        draggableStyle = {
          transform: "translate(".concat(this.state.translateElement.x, "px, ").concat(this.state.translateElement.y, "px)"),
          position: 'fixed',
          top: this.state.elementTopLeft.y,
          left: this.state.elementTopLeft.x
        };
      } else {
        draggableStyle = {
          top: this.state.elementTopLeft.y,
          left: this.state.elementTopLeft.x,
          position: 'fixed',
          margin: '0 !important'
        };
      }

      return React.createElement(React.Fragment, null, React.createElement("div", {
        className: className,
        onClick: this.onClick,
        onDoubleClick: this.onDoubleClick,
        onMouseDown: this.onMouseDown,
        ref: this.element
      }, React.createElement("div", {
        className: "p-x-1"
      }, React.createElement(ImageThumbnail, {
        imageSrc: this.props.imageSrc,
        loading: this.props.loading,
        error: this.props.error,
        stackPercentComplete: this.props.stackPercentComplete
      })), React.createElement("div", {
        className: 'series-details'
      }, React.createElement("div", {
        className: "series-description"
      }, this.props.seriesDescription), React.createElement("div", {
        className: "series-information"
      }, React.createElement("div", {
        className: "item item-series clearfix"
      }, React.createElement("div", {
        className: "icon"
      }, "S:"), React.createElement("div", {
        className: "value"
      }, this.props.seriesNumber)), hasInstanceNumber && React.createElement("div", {
        className: "item item-series clearfix"
      }, React.createElement("div", {
        className: "icon"
      }, "I:"), React.createElement("div", {
        className: "value"
      }, this.props.instanceNumber)), React.createElement("div", {
        className: "item item-frames clearfix"
      }, React.createElement("div", {
        className: "icon"
      }, React.createElement("div", null)), React.createElement("div", {
        className: "value"
      }, this.props.numImageFrames))))), this.state.dragging && React.createElement("div", {
        className: "ThumbnailEntry noselect image-thumbnail-clone",
        style: draggableStyle
      }, React.createElement("div", {
        className: "p-x-1"
      }, React.createElement(ImageThumbnail, {
        imageSrc: this.props.imageSrc,
        loading: this.props.loading,
        error: this.props.error,
        stackPercentComplete: this.props.stackPercentComplete
      })), React.createElement("div", {
        className: 'series-details'
      }, React.createElement("div", {
        className: "series-description"
      }, this.props.seriesDescription), React.createElement("div", {
        className: "series-information"
      }, React.createElement("div", {
        className: "item item-series clearfix"
      }, React.createElement("div", {
        className: "icon"
      }, "S:"), React.createElement("div", {
        className: "value"
      }, this.props.seriesNumber)), hasInstanceNumber && React.createElement("div", {
        className: "item item-series clearfix"
      }, React.createElement("div", {
        className: "icon"
      }, "I:"), React.createElement("div", {
        className: "value"
      }, this.props.instanceNumber)), React.createElement("div", {
        className: "item item-frames clearfix"
      }, React.createElement("div", {
        className: "icon"
      }, React.createElement("div", null)), React.createElement("div", {
        className: "value"
      }, this.props.numImageFrames))))));
    }
  }, {
    key: "dragHandler",
    value: function dragHandler(event) {
      var cursor = ThumbnailEntry.getCursorPosition(event);

      if (supportsTransform) {
        this.setState({
          translateElement: {
            x: cursor.x - this.state.startPosition.x,
            y: cursor.y - this.state.startPosition.y
          }
        });
      } else {
        this.setState({
          elementTopLeft: {
            x: cursor.x - this.state.diff.x,
            y: cursor.y - this.state.diff.y
          }
        });
      }

      this.props.onThumbnailDrag(event); // Prevent default to stop grab-scrolling page on touch devices

      event.preventDefault();
    }
  }, {
    key: "dragStartHandler",
    value: function dragStartHandler(event) {
      var targetThumbnail = event.currentTarget;
      var cursor = ThumbnailEntry.getCursorPosition(event); // Hook up event handlers for mouse events

      if (event.type === 'mousedown') {
        document.addEventListener('mousemove', this.dragHandler);
        document.addEventListener('mouseup', this.dragEndHandler);
      } else if (event.type === 'touchstart') {
        // Mark the event handler as not passive so we can use preventDefault
        document.addEventListener('touchmove', this.dragHandler, {
          passive: false
        });
        document.addEventListener('touchend', this.dragEndHandler, {
          passive: false
        });
      } // This block gets the current offset of the touch/mouse
      // relative to the window
      //
      // i.e. Where did the user grab it from?


      var offset = getOffset(targetThumbnail);
      var left = offset.left,
          top = offset.top; // This difference is saved for later so the element movement looks normal

      var diff = {
        x: cursor.x - left,
        y: cursor.y - top
      }; // This sets the default style properties of the cloned element so it is
      // ready to be dragged around the page

      if (supportsTransform) {
        this.setState({
          startPosition: {
            x: cursor.x,
            y: cursor.y
          },
          diff: diff,
          dragging: true,
          elementTopLeft: {
            x: left,
            y: top
          }
        });
      } else {
        this.setState({
          startPosition: {
            x: cursor.x,
            y: cursor.y
          },
          diff: diff,
          dragging: true,
          elementTopLeft: {
            x: cursor.x - diff.x,
            y: cursor.y - diff.y
          }
        });
      }
    }
  }, {
    key: "dragEndHandler",
    value: function dragEndHandler(event) {
      this.setState({
        diff: {
          x: 0,
          y: 0
        },
        startPosition: {},
        translateElement: {},
        dragging: false,
        elementTopLeft: {}
      });
      document.removeEventListener('mousemove', this.dragHandler);
      document.removeEventListener('mouseup', this.dragEndHandler);
      document.removeEventListener('touchmove', this.dragHandler);
      document.removeEventListener('touchend', this.dragEndHandler);
      var data = {
        seriesDescription: this.props.seriesDescription,
        seriesNumber: this.props.seriesNumber,
        instanceNumber: this.props.instanceNumber,
        numImageFrames: this.props.numImageFrames
      };
      this.props.onThumbnailDrop(event, data);
    }
  }], [{
    key: "getCursorPosition",
    value: function getCursorPosition(event) {
      if (TOUCH_EVENTS.includes(event.type)) {
        return {
          x: event.changedTouches[0].pageX,
          y: event.changedTouches[0].pageY
        };
      }

      return {
        x: event.pageX,
        y: event.pageY
      };
    }
  }, {
    key: "getDropElement",
    value: function getDropElement(event) {
      // Get the touch/mouse coordinates from the event
      var cursor = ThumbnailEntry.getCursorPosition(event); // Note: We need to convert to the viewport coordinate system
      // since document.elementFromPoint does not take page coordinates.

      var viewportPoint = {
        x: cursor.x - window.pageXOffset,
        y: cursor.y - window.pageYOffset
      }; // Identify the element below the current cursor position

      return document.elementFromPoint(viewportPoint.x, viewportPoint.y);
    }
  }]);

  return ThumbnailEntry;
}(Component);

_defineProperty(ThumbnailEntry, "defaultProps", {
  imageSrc: '',
  active: false,
  supportsDragAndDrop: false,
  loading: false,
  error: false,
  stackPercentComplete: undefined,
  onThumbnailDrag: function onThumbnailDrag(event) {
    var elemBelow = ThumbnailEntry.getDropElement(event);
    console.log(elemBelow);
  },
  onThumbnailDrop: function onThumbnailDrop(event) {
    var elemBelow = ThumbnailEntry.getDropElement(event);
    console.log('onThumbnailDrop', elemBelow);
  }
});

_defineProperty(ThumbnailEntry, "propTypes", {
  imageSrc: PropTypes.string.isRequired,
  loading: PropTypes.bool.isRequired,
  error: PropTypes.bool.isRequired,
  supportsDragAndDrop: PropTypes.bool.isRequired,
  active: PropTypes.bool.isRequired,
  stackPercentComplete: PropTypes.number,
  seriesDescription: PropTypes.string,
  seriesNumber: PropTypes.number,
  instanceNumber: PropTypes.number,
  numImageFrames: PropTypes.number,
  onDoubleClick: PropTypes.func,
  onClick: PropTypes.func,
  onThumbnailDrag: PropTypes.func
});

var css$6 = ".StudyBrowser {\n  float: left;\n  height: 100%;\n  width: 100%;\n  overflow: hidden;\n  background-color: #000;\n  padding-bottom: 20px;\n}\n.StudyBrowser .scrollable-study-thumbnails {\n  height: 100%;\n  overflow-y: auto;\n  overflow-x: hidden;\n  padding-bottom: 50px;\n  padding-right: 16px;\n  padding-left: 4px;\n  margin-right: -16px;\n}\n.StudyBrowser .scrollable-study-thumbnails::-webkit-scrollbar {\n  display: none;\n}\n";
styleInject(css$6);

var StudyBrowser =
/*#__PURE__*/
function (_Component) {
  _inherits(StudyBrowser, _Component);

  function StudyBrowser() {
    _classCallCheck(this, StudyBrowser);

    return _possibleConstructorReturn(this, _getPrototypeOf(StudyBrowser).apply(this, arguments));
  }

  _createClass(StudyBrowser, [{
    key: "render",
    value: function render() {
      var _this = this;

      var studies = this.props.studies;
      var thumbnails = studies.map(function (study) {
        return study.thumbnails.map(function (thumb, index) {
          return React.createElement(ThumbnailEntry, _extends({
            key: index
          }, thumb, {
            supportsDragAndDrop: _this.props.supportsDragAndDrop,
            onClick: _this.props.onThumbnailClick,
            onDoubleClick: _this.props.onThumbnailDoubleClick,
            onThumbnailDrag: _this.props.onThumbnailDrag,
            onThumbnailDrop: _this.props.onThumbnailDrop
          }));
        });
      });
      return React.createElement("div", {
        className: "StudyBrowser"
      }, React.createElement("div", {
        className: "scrollable-study-thumbnails"
      }, thumbnails));
    }
  }]);

  return StudyBrowser;
}(Component);

_defineProperty(StudyBrowser, "defaultProps", {
  studies: [],
  supportsDragAndDrop: true
});

_defineProperty(StudyBrowser, "propTypes", {
  studies: PropTypes.array.isRequired,
  supportsDragAndDrop: PropTypes.bool.isRequired,
  onThumbnailClick: PropTypes.func,
  onThumbnailDoubleClick: PropTypes.func,
  onThumbnailDrag: PropTypes.func,
  onThumbnailDrop: PropTypes.func
});

function SimpleToolbarButton(props) {
  var className = classnames(props.className, 'btn btn-sm btn-default');
  return React.createElement("button", {
    id: props.id,
    type: "button",
    className: className,
    "data-container": "body",
    "data-toggle": "tooltip",
    "data-placement": "bottom",
    title: props.title
  }, React.createElement("span", {
    className: props.iconClassName
  }));
}
SimpleToolbarButton.propTypes = {
  iconClassName: PropTypes.string,
  className: PropTypes.string,
  id: PropTypes.string,
  onClick: PropTypes.func
};

/*function toggleCinePlay(element) {
    var viewports = $('.imageViewerViewport');

    if (!element) {
        var viewportIndex = Session.get('activeViewport');
        element = viewports.get(viewportIndex);
    }

    if (!element) {
        return;
    }

    var isPlaying = OHIF.viewer.isPlaying[viewportIndex] || false;
    if (isPlaying) {
        cornerstoneTools.stopClip(element);
    } else {
        cornerstoneTools.playClip(element);
    }

    OHIF.viewer.isPlaying[viewportIndex] = !OHIF.viewer.isPlaying[viewportIndex];
    Session.set('UpdateCINE', Random.id());
};

function isPlaying() {
    Session.get('UpdateCINE');
    var activeViewport = Session.get('activeViewport');

    // TODO=Check best way to make sure this is always defined
    // Right now it is initialized in enableHotkeys AND in
    // imageViewer onCreated, but this appears to break some things
    if (!OHIF.viewer.isPlaying) {
        return;
    }

    return !!OHIF.viewer.isPlaying[activeViewport];
};

/*Template.playClipButton.helpers({
    isPlaying: function() {
        return isPlaying();
    }
});

Template.playClipButton.events({
    'click #playClip': function() {
        toggleCinePlay();
    },
    'click #toggleCineDialog': function() {
        var cineDialog = document.getElementById('cineDialog');
        toggleDialog(cineDialog);
    }
});*/

var PlayClipButton =
/*#__PURE__*/
function (_Component) {
  _inherits(PlayClipButton, _Component);

  function PlayClipButton() {
    _classCallCheck(this, PlayClipButton);

    return _possibleConstructorReturn(this, _getPrototypeOf(PlayClipButton).apply(this, arguments));
  }

  _createClass(PlayClipButton, [{
    key: "render",
    value: function render() {
      var playClass = 'fa-stop';

      if (this.props.isPlaying) {
        playClass = 'fa-play';
      }

      return React.createElement("div", {
        className: "btn-group"
      }, React.createElement("button", {
        id: "playClip",
        type: "button",
        className: "imageViewerCommand btn btn-sm btn-default",
        "data-container": "body",
        "data-toggle": "tooltip",
        "data-placement": "bottom",
        title: "Play/Stop Clip"
      }, React.createElement("span", {
        className: "fa ".concat(playClass)
      })), React.createElement("button", {
        id: "toggleCineDialog",
        type: "button",
        className: "imageViewerCommand btn btn-sm btn-default",
        "data-container": "body",
        "data-toggle": "tooltip",
        "data-placement": "bottom",
        title: "Toggle CINE Dialog"
      }, React.createElement("span", {
        className: "fa fa-youtube-play"
      })));
    }
  }]);

  return PlayClipButton;
}(Component);
PlayClipButton.propTypes = {
  isPlaying: PropTypes.bool.isRequired
};
PlayClipButton.defaultProps = {
  isPlaying: false
};

function getDefaultButtonData() {
  var buttonData = [];
  buttonData.push({
    id: 'wwwc',
    title: 'WW/WC',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-sun-o'
  });
  buttonData.push({
    id: 'wwwcRegion',
    title: 'Window by Region',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-square'
  });
  buttonData.push({
    id: 'magnify',
    title: 'Magnify',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-circle'
  });
  buttonData.push({
    id: 'annotate',
    title: 'Annotation',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-arrows-h'
  });
  buttonData.push({
    id: 'invert',
    title: 'Invert',
    className: 'imageViewerCommand',
    iconClassName: 'fa fa-adjust'
  });
  buttonData.push({
    id: 'zoom',
    title: 'Zoom',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-search'
  });
  buttonData.push({
    id: 'pan',
    title: 'Pan',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-arrows'
  });
  buttonData.push({
    id: 'stackScroll',
    title: 'Stack Scroll',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-bars'
  });
  buttonData.push({
    id: 'length',
    title: 'Length Measurement',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-arrows-v'
  });
  buttonData.push({
    id: 'angle',
    title: 'Angle Measurement',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-angle-left'
  });
  buttonData.push({
    id: 'dragProbe',
    title: 'Pixel Probe',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-dot-circle-o'
  });
  buttonData.push({
    id: 'ellipticalRoi',
    title: 'Elliptical ROI',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-circle-o'
  });
  buttonData.push({
    id: 'rectangleRoi',
    title: 'Rectangle ROI',
    className: 'imageViewerTool',
    iconClassName: 'fa fa-square-o'
  });
  buttonData.push({
    id: 'resetViewport',
    title: 'Reset Viewport',
    className: 'imageViewerCommand',
    iconClassName: 'fa fa-undo'
  });
  buttonData.push({
    id: 'clearTools',
    title: 'Clear tools',
    className: 'imageViewerCommand',
    iconClassName: 'fa fa-trash'
  });
  return buttonData;
}
/*Template.toolbar.events({
    'click .imageViewerTool': function(e) {
        $(e.currentTarget).tooltip('hide');

        var tool = e.currentTarget.id;

        var elements = $('.imageViewerViewport');

        var activeTool = toolManager.getActiveTool();
        if (tool === activeTool) {
            var defaultTool = toolManager.getDefaultTool();
            console.log('Setting active tool to: ' + defaultTool);
            toolManager.setActiveTool(defaultTool, elements);
        } else {
            console.log('Setting active tool to: ' + tool);
            toolManager.setActiveTool(tool, elements);
        }
    },
    'click .imageViewerCommand': function(e) {
        $(e.currentTarget).tooltip('hide');

        var command = e.currentTarget.id;
        if (!OHIF.viewer.functionList.hasOwnProperty(command)) {
            return;
        }

        var activeViewport = Session.get('activeViewport');
        var element = $('.imageViewerViewport').get(activeViewport);
        OHIF.viewer.functionList[command](element);
    }
});

Template.toolbar.onRendered(function() {
    var tooltipButtons = $('[data-toggle="tooltip"]');
    tooltipButtons.tooltip(OHIF.viewer.tooltipConfig);

    // Enable tooltips for the layout button
    var extraTooltipButtons = $('[rel="tooltip"]');
    extraTooltipButtons.tooltip(OHIF.viewer.tooltipConfig);

    // Set disabled/enabled tool buttons that are set in toolManager
    var states = toolManager.getToolDefaultStates();
    var disabledToolButtons = states.disabledToolButtons;
    var allToolbarButtons = $('#toolbar').find('button');
    if (disabledToolButtons.length > 0) {
        for (var i = 0; i < allToolbarButtons.length; i++) {
            var toolbarButton = allToolbarButtons[i];
            $(toolbarButton).prop('disabled', false);
            var index = disabledToolButtons.indexOf($(toolbarButton).attr('id'));
            if (index !== -1) {
                $(toolbarButton).prop('disabled', true);
            }
        }
    }
});*/


var Toolbar =
/*#__PURE__*/
function (_Component) {
  _inherits(Toolbar, _Component);

  function Toolbar() {
    _classCallCheck(this, Toolbar);

    return _possibleConstructorReturn(this, _getPrototypeOf(Toolbar).apply(this, arguments));
  }

  _createClass(Toolbar, [{
    key: "render",
    value: function render() {
      var maybePlayClipButton;

      if (this.props.includePlayClipButton) {
        maybePlayClipButton = React.createElement(PlayClipButton, null);
      }

      var maybeLayoutButton;

      if (this.props.includeLayoutButton) {
        maybeLayoutButton = React.createElement(LayoutButton, null);
      }

      return React.createElement("div", {
        id: "toolbar"
      }, React.createElement("div", {
        className: "btn-group"
      }, this.props.buttons.map(function (button, i) {
        return React.createElement(SimpleToolbarButton, _extends({}, button, {
          key: i
        }));
      }), maybePlayClipButton, maybeLayoutButton));
    }
  }]);

  return Toolbar;
}(Component);
Toolbar.propTypes = {
  buttons: PropTypes.array.isRequired,
  includeLayoutButton: PropTypes.bool.isRequired,
  includePlayClipButton: PropTypes.bool.isRequired
};
Toolbar.defaultProps = {
  buttons: getDefaultButtonData(),
  includeLayoutButton: true,
  includePlayClipButton: true
};

var css$7 = ":root {\n  --text-secondary-color: #91b9cd;\n  --default-color: #9ccef9;\n  --active-color: #20a5d6;\n  --hover-color: #fff;\n  --ui-gray-darkest: #14202a;\n}\n.CineDialog {\n  background: var(--ui-gray-darkest);\n  color: var(--text-secondary-color);\n  filter: drop-shadow(0 0 3px rgba(0,0,0,0.85));\n  border: none;\n  border-radius: 8px;\n  width: inherit;\n}\n.CineDialog h5 {\n  font-size: 20px;\n  line-height: 35px;\n  margin: 0;\n}\n.CineDialog h5,\n.CineDialog label {\n  font-weight: 400;\n}\n.CineDialog .btn {\n  color: var(--text-secondary-color);\n  background-color: transparent;\n}\n.CineDialog .btn:hover {\n  color: var(--hover-color);\n}\n.CineDialog .btn:active,\n.CineDialog .btn.active {\n  color: var(--active-color);\n}\n.CineDialog .btn[disabled]:hover {\n  color: inherit;\n}\n.CineDialog .btn[disabled]:active {\n  color: var(--text-secondary-color);\n}\n.CineDialog .cine-navigation,\n.CineDialog .cine-controls,\n.CineDialog .cine-options {\n  cursor: default;\n}\n.CineDialog .fps-section input[type=\"range\"] {\n  background-color: transparent;\n  border: 0 none;\n  outline: 0 none;\n}\n.CineDialog .fps-section input[type=\"range\"]::-ms-tooltip {\n  display: none;\n}\n.CineDialog .double-row-style {\n  box-sizing: border-box;\n  width: 290px;\n  height: 80px;\n  padding: 10px;\n  top: 2%;\n  left: 35%;\n}\n.CineDialog .double-row-style .cine-navigation {\n  position: absolute;\n  right: 16px;\n  top: 10px;\n}\n.CineDialog .double-row-style .cine-navigation .btn {\n  padding: 0 4px;\n}\n.CineDialog .double-row-style .cine-navigation .btn i {\n  font-size: 32px;\n  line-height: 32px;\n}\n.CineDialog .double-row-style .cine-controls {\n  left: 0px;\n}\n.CineDialog .double-row-style .cine-options {\n  padding: 0px 0;\n}\n.CineDialog .double-row-style .cine-options .fps-section {\n  width: 175px;\n  float: left;\n}\n.CineDialog .double-row-style .cine-options .fps {\n  float: right;\n  margin: 5px 20px 0 0;\n}\n.CineDialog .single-row-style {\n  box-sizing: content-box;\n  width: 425px;\n  height: 45px;\n  padding: 4px 8px;\n  top: 2%;\n  left: 35%;\n}\n.CineDialog .single-row-style .cine-navigation {\n  float: right;\n  overflow: hidden;\n  padding-right: 12px;\n  position: relative;\n}\n.CineDialog .single-row-style .cine-navigation .btn {\n  padding: 0 2px;\n  margin: 0 0 0 2px;\n  border: 0 none;\n}\n.CineDialog .single-row-style .cine-navigation .btn:first-of-type {\n  margin-left: 0;\n}\n.CineDialog .single-row-style .cine-navigation .btn i {\n  font-size: 32px;\n  line-height: 45px;\n}\n.CineDialog .single-row-style .cine-controls {\n  position: relative;\n  float: left;\n  overflow: hidden;\n}\n.CineDialog .single-row-style .cine-controls .btn {\n  font-size: 22px;\n  line-height: 45px;\n  min-width: 28px;\n  padding: 0 0px;\n  margin: 0 4px;\n  border: 0 none;\n}\n.CineDialog .single-row-style .cine-options {\n  display: block;\n  position: relative;\n  width: 150px;\n  float: left;\n  overflow: hidden;\n  padding: 0;\n  margin: 0 0 0 10px;\n}\n.CineDialog .single-row-style .cine-options .fps-section {\n  display: block;\n  float: left;\n  width: 80px;\n}\n.CineDialog .single-row-style .cine-options .fps-section input[type=\"range\"] {\n  line-height: 45px;\n  height: 45px;\n}\n.CineDialog .single-row-style .cine-options .fps {\n  display: block;\n  width: 68px;\n  float: left;\n  padding: 0;\n  margin: 0 0 0 2px;\n  text-align: center;\n  line-height: 45px;\n  font-size: 14px;\n  line-height: 1.42857143;\n}\n.CineDialog .btn {\n  border: 0;\n  border-radius: 4px;\n  font-size: 15px;\n  font-weight: normal;\n  height: 37px;\n  line-height: 37px;\n  padding: 0 12px;\n}\n.CineDialog .btn.btn-primary,\n.CineDialog .btn.btn-secondary {\n  color: #000;\n}\n.CineDialog .btn.btn-primary:hover,\n.CineDialog .btn.btn-secondary:hover,\n.CineDialog .btn.btn-primary:active,\n.CineDialog .btn.btn-secondary:active,\n.CineDialog .btn.btn-primary:focus,\n.CineDialog .btn.btn-secondary:focus,\n.CineDialog .btn.btn-primary:focus:active,\n.CineDialog .btn.btn-secondary:focus:active {\n  color: #000;\n}\n.CineDialog .btn.btn-primary,\n.CineDialog .btn.btn-secondary,\n.CineDialog .btn.btn-danger {\n  transition: background-color 0.3s ease;\n}\n.CineDialog .btn.btn-primary {\n  background-color: var(--active-color);\n}\n.CineDialog .btn.btn-primary:hover,\n.CineDialog .btn.btn-primary:active,\n.CineDialog .btn.btn-primary:focus,\n.CineDialog .btn.btn-primary:focus:active {\n  opacity: 0.8;\n}\n.CineDialog .btn.btn-secondary {\n  background-color: var(--text-secondary-color);\n}\n.CineDialog .btn.btn-secondary:hover,\n.CineDialog .btn.btn-secondary:active,\n.CineDialog .btn.btn-secondary:focus,\n.CineDialog .btn.btn-secondary:focus:active {\n  opacity: 0.8;\n}\n.CineDialog .btn.btn-danger {\n  background-color: var(--text-destructive-color);\n  color: var(--text-primary-color);\n}\n.CineDialog .btn.active {\n  box-shadow: inset 1px 1px 2px rgba(0,0,0,0.5);\n}\n";
styleInject(css$7);

var CineDialog =
/*#__PURE__*/
function (_Component) {
  _inherits(CineDialog, _Component);

  function CineDialog(props) {
    var _this;

    _classCallCheck(this, CineDialog);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CineDialog).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleInputChange", function (event) {
      var target = event.target;
      var value = target.value;

      if (target.type === 'checkbox') {
        value = target.checked;
      } else if (target.type === 'range') {
        value = parseFloat(target.value);
      }

      var name = target.name;

      _this.setState(_defineProperty({}, name, value));

      if (name === 'cineFrameRate' && _this.props.onFrameRateChanged) {
        _this.props.onFrameRateChanged(parseFloat(value));
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClickPlayPause", function () {
      var value = !_this.state.isPlaying;

      _this.setState({
        isPlaying: value
      });

      if (_this.props.onPlayPauseChanged) {
        _this.props.onPlayPauseChanged(value);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClickNextButton", function (event) {
      if (_this.props.onClickNextButton) {
        _this.props.onClickNextButton(event);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClickBackButton", function (event) {
      if (_this.props.onClickBackButton) {
        _this.props.onClickBackButton(event);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClickSkipToStart", function (event) {
      if (_this.props.onClickSkipToStart) {
        _this.props.onClickSkipToStart(event);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClickSkipToEnd", function (event) {
      if (_this.props.onClickSkipToEnd) {
        _this.props.onClickSkipToEnd(event);
      }
    });

    _this.state = {
      cineFrameRate: props.cineFrameRate,
      isPlaying: props.isPlaying
    };
    return _this;
  }

  _createClass(CineDialog, [{
    key: "render",
    // TODO:
    // - Add next / previous display set buttons which just call
    // onClickNextDisplaySet and onClickPreviousDisplaySet which are passed in as props.
    // See https://github.com/OHIF/Viewers/blob/master/Packages/ohif-viewerbase/client/components/viewer/cineDialog/cineDialog.html#L38
    // - Add 'isEnabled' prop: https://github.com/OHIF/Viewers/blob/master/Packages/ohif-viewerbase/client/components/viewer/cineDialog/cineDialog.js#L301
    value: function render() {
      return React.createElement("div", {
        className: "CineDialog"
      }, React.createElement("div", {
        className: "noselect double-row-style"
      }, React.createElement("div", {
        className: "cine-controls"
      }, React.createElement("div", {
        className: "btn-group"
      }, React.createElement("button", {
        id: "cineFirstButton",
        title: "Skip to first image",
        className: "btn",
        "data-toggle": "tooltip",
        onClick: this.onClickSkipToStart
      }, React.createElement("i", {
        className: "fa fa-lg fa-fast-backward"
      })), React.createElement("button", {
        id: "cineBackButton",
        title: "Previous image",
        className: "btn",
        "data-toggle": "tooltip",
        onClick: this.onClickBackButton
      }, React.createElement("i", {
        className: "fa fa-lg fa-step-backward"
      })), React.createElement("button", {
        id: "cinePlayButton",
        title: "Play / Stop",
        className: "btn",
        "data-toggle": "tooltip",
        onClick: this.onClickPlayPause
      }, React.createElement("i", {
        className: this.state.isPlaying ? 'fa fa-lg fa-stop' : 'fa fa-lg fa-play'
      })), React.createElement("button", {
        id: "cineNextButton",
        title: "Next image",
        className: "btn",
        "data-toggle": "tooltip",
        onClick: this.onClickNextButton
      }, React.createElement("i", {
        className: "fa fa-lg fa-step-forward"
      })), React.createElement("button", {
        id: "cineLastButton",
        title: "Skip to last image",
        className: "btn",
        "data-toggle": "tooltip",
        onClick: this.onClickSkipToEnd
      }, React.createElement("i", {
        className: "fa fa-lg fa-fast-forward"
      })))), React.createElement("div", {
        className: "cine-options"
      }, React.createElement("div", {
        className: "fps-section"
      }, React.createElement("input", {
        type: "range",
        name: "cineFrameRate",
        id: "cineSlider",
        min: this.props.cineMinFrameRate,
        max: this.props.cineMaxFrameRate,
        step: this.props.cineStepFrameRate,
        value: this.state.cineFrameRate,
        onChange: this.handleInputChange
      })), React.createElement("span", {
        className: "fps"
      }, this.state.cineFrameRate.toFixed(1), " fps"))));
    }
  }]);

  return CineDialog;
}(Component);

_defineProperty(CineDialog, "propTypes", {
  cineMinFrameRate: PropTypes.number.isRequired,
  cineMaxFrameRate: PropTypes.number.isRequired,
  cineStepFrameRate: PropTypes.number.isRequired,
  cineFrameRate: PropTypes.number.isRequired,
  isPlaying: PropTypes.bool.isRequired,
  onPlayPauseChanged: PropTypes.func,
  onFrameRateChanged: PropTypes.func,
  onClickNextButton: PropTypes.func,
  onClickBackButton: PropTypes.func,
  onClickSkipToStart: PropTypes.func,
  onClickSkipToEnd: PropTypes.func
});

_defineProperty(CineDialog, "defaultProps", {
  cineMinFrameRate: 1,
  cineMaxFrameRate: 90,
  cineStepFrameRate: 1,
  cineFrameRate: 24,
  isPlaying: false
});

var css$8 = ".StudyList {\n  height: 100%;\n  width: 100%;\n}\n";
styleInject(css$8);

var StudyList =
/*#__PURE__*/
function (_Component) {
  _inherits(StudyList, _Component);

  function StudyList(props) {
    _classCallCheck(this, StudyList);

    return _possibleConstructorReturn(this, _getPrototypeOf(StudyList).call(this, props));
  }

  _createClass(StudyList, [{
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: "StudyList"
      }, "'studies'");
    }
  }]);

  return StudyList;
}(Component);

_defineProperty(StudyList, "propTypes", {
  studies: PropTypes.array
});

export { RoundedButtonGroup, LayoutChooser, LayoutButton, ToolbarSection, StudyBrowser, ThumbnailEntry, Toolbar, PlayClipButton, LayoutManager, CineDialog, StudyList };
//# sourceMappingURL=index.es.js.map
